﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

#endregion


using de.WWWings;
using de.WWWings.PassagierSystem;
using de.WWWings.MitarbeiterSystem;
using de.ITVisions.DemoViewer;

namespace de.WWWings.ConsoleClient
{

 public class FluggesellschaftClient
 {


 

  //public static void DAL_Test1()
  //{

  // Console.WriteLine(new de.WWWings.Info().GetComponentInfoString());

  // for (int a = 0; a < 10; a++)
  // {
  //  de.WWWings.DAL.Flug_DataManager fm = new de.WWWings.DAL.Flug_DataManager();

  //  System.Data.DataSet ds = fm.AlleFluege_DS();

  //  Console.WriteLine(ds.Tables[0].Rows.Count);
  // }
  //}

  public static void DAL_Test2()
  {
 
   Console.WriteLine(new de.WWWings.Info().GetComponentInfoString());
 
   Passagier p1 = new Passagier("Schröder", "Gerhard");
   Console.WriteLine("Buchungen vorher: ");
   Util.ReaderToConsole(p1.AlleBuchungen());
   Console.WriteLine("Buchungen gelöscht: " + p1.AlleBuchungenLoeschen());

   Console.WriteLine("Einzelbuchung...");
   Console.WriteLine("Flug 102 gebucht. Restplätze: " + p1.Buchen(102));
   Console.WriteLine("Mehrfachbuchung...");
   long[] FlugNummern = new long[] { 100, 200, 300, 400 };
   p1.Buchen(FlugNummern);
   Console.WriteLine("fertig!");
   Console.WriteLine("Buchungen nachher: ");
   Util.ReaderToConsole(p1.AlleBuchungen());
 
  }

  public static void Run()
  {
 



   //Passagier.CheckInStart += new Passagier.CheckInStartHandler(CheckInGestartet);
   Passagier.CheckInEnde += delegate(Passagier CheckedInPassagier)
   {
    Int16 AnzahlPass = 0;
    AnzahlPass += 1;
    Console.WriteLine(AnzahlPass + ". Passagier: " + CheckedInPassagier.GanzerName);
   };

   Flug f1 = new Flug("NF1234", "Düsseldorf", "München");
   Flug f2 = new Flug("NF5678", "Düsseldorf", "New York");
   Passagier p1 = new Passagier("Schröder", "Gerhard");
   Passagier p2 = new Passagier("Merkel", "Angela");
   p1.Buchen("NF1234");
   p1.Buchen("NF5678");
   f1 = f1 + p2;
   p1.CheckIn("NF1234");

   try
   {
    p2.CheckIn("NF5678");
   }
   catch (de.WWWings.PassagierSystem.PassagierNichtAufFlugGebucht ex)
   {
    Console.WriteLine("Einchecken nicht möglich, da Passagier nicht auf diesen Flug gebucht ist!");
   }
   catch (Exception ex)
   {
    Console.WriteLine("Es ist ein unerwarteter Fehler aufgetreten: " + ex.Message);
   }
   Console.WriteLine("Gesamtanzahl der Flüge: " + Flug.Fluege.Count);
   Console.WriteLine("Gesamtanzahl der Passagiere: " + Passagier.Passagiere.Count);
   foreach (Passagier p in Passagier.Passagiere.Values)
   {
    Console.WriteLine(p.GanzerName + " hat " + p.Fluege.Count + " gebucht!");
    if (!(p.AktuellerFlug == null))
    {
     Console.WriteLine("Aktueller Flug: " + p.AktuellerFlug.FlugNr);
    }
   }
   // Generische Typen nutzen
   Mitarbeiterzuordnung<Pilot, Pilot> CockpitTeam;
   Pilot Pilot1 = new Pilot("Müller", "Max");
   Pilot Pilot2 = new Pilot("Meier", "Hans");
   CockpitTeam = new Mitarbeiterzuordnung<Pilot, Pilot>(Pilot1, Pilot2);
   f1.Pilot = Pilot1;

   // Typkonvertierungen
   Passagier pass = new Passagier("Schröder", "Gerhard");
   Person pers = new Person("Merkel", "Angela");
   pers = ((Person)pass);
   pass = (pers as Passagier);

   System.Collections.ArrayList a = new System.Collections.ArrayList();
   a.Add(new Object());

   pass = (a[0] as Passagier);
   //  pass = ((Passagier)a[0]);

   //  pass.Info();
   //  pers.Info();
   int zahl = 1;
   //  string text = zahl;


  }

  static void CheckInGestartet(Passagier pass)
  {
   Console.WriteLine("Check-In beginnt... für " + pass.GanzerName);
  }


 }
}